<?

require($ADEI_ROOTDIR . "/classes/searchengine.php");

class SEARCH {
 var $engines;
 var $modules;
 
 function __construct(REQUEST $req) {
    global $SEARCH_ENGINES;

    $this->modules = array();
    $this->engines = array();
    
    foreach ($SEARCH_ENGINES as $cl => &$opts) {
	if (!include_once("search/" . strtolower($cl) . '.php')) {
	    throw new ADEIException(translate("Unsupported search engine is configured: \"%s\"", $cl));
	}
    
    	$engine = new $cl($req, $opts);
	$modules = $engine->GetModules();
	
	foreach ($modules as $module) {
	    if (isset($this->modules[$module])) {
		throw new ADEIException(translate("SEARCH engines are conflicting. Module (%s) is provided by two different engines: \"" . get_class($this->modules[$module]) . "\" and \"$cl\""));
	    }
	    $this->modules[$module] = $engine;
	}
	
	$this->engines[$cl] = $engine;
    }
 }
 
 
 function Search($string = false, $modules = false, $threshold = false) {
    if ($string === false) $string = $this->req->props['search'];

    if (($modules === false)&&($this->req->props['search_modules'])) {
	$modules = $this->req->props['search_modules'];
    }

    if (($threshold === false)&&(isset($this->req->props['search_threshold']))) {
	$threshold = $this->req->props['search_threshold'];
    }
    
    if (($modules)&&(is_string($modules))) {
	if (strpos($modules, "{") === false) {
	    $mstr = explode(",", $modules);
	    $modules = array();
	    foreach ($mstr as $mod) {
		if (preg_match("/^([\w\d_]+)(\(.*\))$/", $mod, $m)) {
		    $module = $m[1];
		    $modules[$module] = array();
		    
		    if ($m[2]) {
			$params = explode(";", $m[2]);
			foreach ($params as $param) {
			    if (preg_match("/^([^=]+)=(.*)$/", $param, $m)) {
				$modules[$module][$m[1]] = $m[2];
			    } else {
				$modules[$module][$param] = true;
			    }
			}
		    }
		}
	    }
	} else {
	    $modules = json_decode($modules);
	}
    }
    
    if ($modules) {
	$result = array();
	
	foreach ($modules as $module => $opts) {
	    if (isset($this->modules[$module])) {
	        $result[$module] = $this->modules[$module]->Search($string, $module, $opts, $threshold);
	    } else {
		throw new ADEIException(translate("The requested search module (%s) is not provided by any of search engines", $module));
	    }
	}
    } else {
	foreach ($this->engines as $engine) {
	    $engine->EngineSearch($string, $threshold);
	}
    }
    
 }
 
}

?>