<?php

interface SEARCHEngineInterface {
 public function GetModules();
 
 public function CheckPhrase($info, $phrase, $module, $opts);
 public function GetList($search_data, $module, $opts);
}

class SEARCHEngine {
 var $req;
 var $opts;
 var $modules;
 
 function __construct(REQUEST $req = NULL, $opts = false) {
    $this->req = $req;
    $this->opts = $opts;
 }
 
 function GetModules() {
    if ($this->modules) {
	return $this->modules;
    }
    
    $cname = get_class($this);
    
    if (preg_match("/^(.*)Search$/i", $cname, $m)) {
	return array(strtolower($m[1]));
    } else {
	return array(strtolower($cname));
    }
 }
 
 function CheckTitlePhrase($title, $phrase, $opts = false) {
	// exact match?
	// regular expressions to cover random number of spaces/tabs?
    return (stripos($title, $phrase) === false)?0:1;
 }
 
 function CheckString(&$info, $string, $module, &$opts) {
    $s = new SEARCHOptions($this, $module, $opts, $info);
 
    $string = preg_replace_callback("/((([\"'])([^\"']+)\\3)|(\b([^\s]+)\b))/", 
	array($s, 'CheckStringCallback'),
	$string
    );
    
    echo $string . "\n";
    
    do {
	/*
	    http://www.fiction.net/tidbits/computer/true_story_unix.html 
	*/
	$string = preg_replace(
	    array(
		"/!\s*((?P<p>\(((?>[^()]+)|(?P>p))+\))|(?>\d+))/",
		"/-\s*((?P<p>\(((?>[^()]+)|(?P>p))+\))|(?>\d+))/",
		"/\+\s*((?P<p>\(((?>[^()]+)|(?P>p))+\))|(?>\d+))/",
		"/(?P<a>(?P<ap>\(((?>[^()]+)|(?P>ap))+\))|(?>\d+))\s*\|\s*(?P<b>(?P<bp>\(((?>[^()]+)|(?P>bp))+\))|(?>\d+))/",
		"/(?P<a>(?P<ap>\(((?>[^()]+)|(?P>ap))+\))|(?>\d+))\s*(?:&|\s)\s*(?P<b>(?P<bp>\(((?>[^()]+)|(?P>bp))+\))|(?>\d+))/",
	    ),
	    array(
		"(1minus$1)",
		"(($1==0)?1:0)",
		"(($1==1)?1:0)",
		"(max($1,$4))",
		"$1*$4"
	    ),
	    $string, -1, $nrep
	);
    } while ($nrep);

    $string = preg_replace("/minus/", "-", $string);

    echo $string . "\n";
    
    eval("\$res=$string;");
    echo "final: $res ({$info['name']})\n";
    return $res;
 }
 
 function ParseString($string) {
/*
    if (preg_match_all("/((([\"'])([^\"']+)\\3)|(\b([^\s]+)\b))/", $string, $m, PREG_PATTERN_ORDER)) {
	print_r($m[4]);
	print_r($m[6]);
    }
*/

    return $string;
 }
 
 function CreateResult($module, &$opts) {
    return array(
	'module' => $module,
	'title' => $this->modules[$module]['title'],
	'results' => array()
    );
 }
 
 function AppendResult(&$result, $key, &$info, $rating) {
    $info['rating'] = $rating;
    $result['results'][$key] = $info;
 }
 
 function Search($search_string, $module, $opts, $threshold = 0) {
    $search_data = $this->ParseString($search_string, $module, $opts);

    $res = $this->CreateResult($module, $opts);
    
    // get list, loop
    $list = $this->GetList($search_data, $module, $opts);
    foreach ($list as $key => $info) {
	$rating = $this->CheckString($info, $search_data, $module, $opts);
	if ($rating > $threshold) {
	    $this->AppendResult($res, $key, $info, $rating);
	}
    }
    
    return $res;
 }
 
 function EngineSearch($search_string, $threshold = 0) {
    return false;
 }
}

class SEARCHOptions {
 var $engine;
 var $module;
 var $opts;
 var $info;
    
 function __construct($engine, $module, &$opts, &$info) {
    $this->engine = $engine;
    $this->module = $module;
    $this->opts = &$opts;
    $this->info = &$info;
 }
 
 function CheckStringCallback($m) {
    $phrase = $m[4]?$m[4]:$m[6];
#    echo $phrase . "\n";
    return $this->engine->CheckPhrase($this->info, $phrase, $this->module, $this->opts);
 }
}

?>