<?php
require("../adei.php");

header("Content-type: text/xml");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

/*
echo "<?xml version='1.0' ?>";
echo "<menu maxItems=\"1\" name=\"\">";
echo "<MenuItem name=\"\" src=\"menu.png\" id=\"main_file\" width=\"20px\" withoutImages=\"yes\"/>";
echo "</menu>";
return;
*/

function ListExperiments(&$list, &$query) {
    foreach ($list as $eid => $exp) {
	$exp_name = xml_escape($exp["name"]);
	$equery = $query .  "__" . $exp['start'] . "-" . $exp['stop'];
	$res .= "<MenuItem name=\"$exp_name\" id=\"SetQuery__$equery\"/>";
    }

    return $res;
}

try {
    $req = new REQUEST();
    $list = $req->GetSources(REQUEST::LIST_ALL);
    
    $data = "";
    $source = "";
    foreach ($list as $sreq) {
	$src_name = xml_escape($sreq->props['db_server'] . "." . $sreq->props['db_name']);
	$query = $sreq->props['db_server'] . "__" . $sreq->props['db_name'];

	try {
	    $s_data = "<MenuItem name=\"$src_name\" id=\"SetQuery__$query\" withoutImages=\"yes\">";
	    $s_source = "<MenuItem name=\"$src_name\" id=\"SetSource__$query\" withoutImages=\"yes\">";

	    $reader = $sreq->CreateReader();
	    $groups = $reader->GetGroupList();
	
	    $glist = $sreq->GetGroups();
	    foreach ($glist as $gid => $greq) {
		$group = &$groups[$gid];
	    
		$gr_name = xml_escape($group['name']);
		$gquery = $query .  "__" . $gid;
		$s_data .= "<MenuItem name=\"$gr_name\" id=\"SetQuery__$gquery\" withoutImages=\"yes\">";
		$s_source .= "<MenuItem name=\"$gr_name\" id=\"SetSource__$gquery\" withoutImages=\"yes\">";
	    
		$cache = $greq->CreateCache($reader);
		$explist = $cache->GetExperimentList();


	        $mlist = $cache->GetMaskList();
		foreach ($mlist as $mid => $mask) {
		    $mask_name = xml_escape($mask['name']);
		    $mquery = $gquery .  "__" . $mid;
		    $s_data .= "<MenuItem name=\"$mask_name\" id=\"SetQuery__$mquery\" withoutImages=\"yes\">";
		    $s_source .= "<MenuItem name=\"$mask_name\" id=\"SetSource__$mquery\"/>";
		    $s_data .= ListExperiments($explist, $mquery);
		    $s_data .= "</MenuItem>";
		}

	        if ($MENU_SHOW_ITEMS) {
		    $s_data .= "<MenuItem name=\"" . _("Items") . "\" id=\"folder__$gquery\" withoutImages=\"yes\">";
		    $s_source .= "<MenuItem name=\"" . _("Items") . "\" id=\"folder__$gquery\" withoutImages=\"yes\">";
		}
	    
		$ilist = $cache->GetItemList();
	        unset($aid);
		foreach ($ilist as $iid => &$item) {
		    if (isset($aid)) $aid .= ",$iid";
		    else $aid = $iid;

		    if ($MENU_SHOW_ITEMS) {
			$item_name = xml_escape($item["name"]);
			$iquery = $gquery .  "__" . $iid;
			$s_data .= "<MenuItem name=\"$item_name\" id=\"SetQuery__$iquery\" withoutImages=\"yes\">";
			$s_source .= "<MenuItem name=\"$item_name\" id=\"SetSource__$iquery\" />";
			$s_data .= ListExperiments($explist, $iquery);
			$s_data .= "</MenuItem>";
		    }
		}
	    
		if ($MENU_SHOW_ITEMS) {
    		    $s_data .= "</MenuItem>";
		    $s_source .= "</MenuItem>";
		}

		$aquery = $gquery .  "__" . $aid;
	        $s_data .= "<MenuItem name=\"" . _("All Items") . "\" id=\"SetQuery__$aquery\" withoutImages=\"yes\">";
		$s_source .= "<MenuItem name=\"" . _("All Items") . "\" id=\"SetSource__$aquery\" />";
		$s_data .= ListExperiments($explist, $aquery);
		$s_data .= "</MenuItem>";

		$s_data .= "</MenuItem>";
		$s_source .= "</MenuItem>";
	    }

	    $s_data .= "</MenuItem>";
	    $s_source .= "</MenuItem>";
	} catch (ADEIException $ae) {
	    $ae->logInfo(NULL, $req);
	    $errmsg = xml_escape($ae->getInfo());

	    $s_data = "
		<MenuItem name=\"$src_name\" withoutImages=\"yes\">
		    <MenuItem name=\"" . translate("Data source is failed, error: %s", $errmsg) . "\" withoutImages=\"yes\"/>
		</MenuItem>
	    ";
	
	    $s_source = $s_data;
	}
	
	$data .= $s_data;
	$source .= $s_source;
    }


    $range = "<MenuItem name=\"" . _("All") . "\" id=\"SetWindow__0\"/>";
    foreach ($ADEI_TIMINGS as $opt => $value) {
	$range .= "<MenuItem name=\"$opt\" id=\"SetWindow__$value\"/>";
    }


    $export .= "";
    $export .= "<MenuItem name=\"" . _("Format") . "\" id=\"folder__SetFormat\" withoutImages=\"yes\">";
    foreach ($EXPORT_FORMATS as $id => &$val) {
	if ((($val['title'])||($val['hidden'] === false))&&(!$val['hidden'])) {
	    $name = $val['title'];
	    $export .= "<MenuItem name=\"$name\" id=\"SetFormat__$id\"/>";
	}
    }
    $export .= "</MenuItem>";

    $export .= "<MenuItem name=\"" . _("Sampling") . "\" id=\"folder__SetExportSampling\" withoutImages=\"yes\">";
    $export .= "<MenuItem name=\"" . _("No Resampling") . "\" id=\"SetExportSampling__0\"/>";
    foreach ($EXPORT_SAMPLING_RATES as $name => $id) {
	$export .= "<MenuItem name=\"$name\" id=\"SetExportSampling__$id\"/>";
    }
    $export .= "</MenuItem>";

    $export .= "<MenuItem name=\"" . _("Exported Items") . "\" id=\"folder__SetExportMask\" withoutImages=\"yes\">";
    $export .= "<MenuItem name=\"" . _("Current Mask") . "\" id=\"SetExportMask__" . EXPORT::MASK_STANDARD  . "\"/>";
    $export .= "<MenuItem name=\"" . _("Current Group") . "\" id=\"SetExportMask__" . EXPORT::MASK_GROUP . "\"/>";
    $export .= "<MenuItem name=\"" . _("Current Database") . "\" id=\"SetExportMask__" . EXPORT::MASK_SOURCE . "\"/>";
    $export .= "<MenuItem name=\"" . _("Everything") . "\" id=\"SetExportMask__" . EXPORT::MASK_COMPLETE . "\"/>";
    $export .= "</MenuItem>";

} catch(ADEIException $ex) {
    $ex->logInfo(NULL, $req);
    $err = xml_escape($ex->getInfo());
}

if ($err) {
    $menu = "<?xml version='1.0' ?>
<menu maxItems=\"1\" name=\"\">
 <MenuItem name=\"\" src=\"menu.png\" id=\"main_file\" width=\"20px\" withoutImages=\"yes\">
  <MenuItem name=\"" . translate("Menu Generation is failed, error: %s", $err) . "\" id=\"folder__data\" withoutImages=\"yes\"/>
 </MenuItem>
</menu>";
    echo $menu;
    return;
}


$menu = "<?xml version='1.0' encoding='UTF-8'?>
<menu  absolutePosition=\"auto\" mode=\"popup\" maxItems=\"10\" name=\"\">
 <MenuItem name=\"\" src=\"menu.png\" id=\"main_file\" width=\"20px\" withoutImages=\"yes\">
  <MenuItem name=\"" . _("New Query") . "\" id=\"folder__data\" withoutImages=\"yes\">" . $data . "</MenuItem>
  <MenuItem name=\"" . _("Data Source") . "\" id=\"folder__data_source\" withoutImages=\"yes\">" . $source . "</MenuItem>
  <MenuItem name=\"" . _("Time Range") . "\" id=\"folder__data_range\" withoutImages=\"yes\">" . $range . "</MenuItem>
  <MenuItem name=\"" . _("Export Settings") . "\" id=\"folder__data_export\" withoutImages=\"yes\">" . $export . "</MenuItem>
  <divider id=\"div_1\"/>	
  <MenuItem name=\"" . _("Save Mask") . "\" id=\"SaveMask\" withoutImages=\"yes\"/>
  <MenuItem name=\"" . _("Save Window") . "\" id=\"SaveWindow\"  withoutImages=\"yes\"/>
  <divider id=\"div_2\"/>	
  <MenuItem name=\"" . _("Lock Window") . "\" id=\"LockWindow\" withoutImages=\"yes\"/>
  <MenuItem name=\"" . _("ReDraw") . "\" id=\"ReDraw\" withoutImages=\"yes\"/>
  <MenuItem name=\"" . _("Save") . "\" id=\"ExportWindow\"/>
 </MenuItem>
</menu>";


echo $menu;
?>