<?php
    $TITLE = "ADEI";
    $MODULES = array("config", "graph", "help");


    $READER_DB_TEST = array (
	"autogen" => array (
	    "title" => _("Generator"),
	    "reader" => "TESTReader",
	    "database" => array("minutely")
	),
    );


    if (is_array($READER_DB)) $READER_DB = array_merge($READER_DB_TEST, $READER_DB);
    else $READER_DB = $READER_DB_TEST;


    $test_items = array(
	array(
	    "name" => _("Noisy Line"),
	    "func" => '$y=-8',
	    "noise" => 0.5
	),
	array(
	    "name" => _("Cosinus"),
	    "func" => '$y=cos(deg2rad($x/$period))'
	),
	array(
	    "name" => _("Noisy Cosinus"),
	    "func" => '$y=cos(deg2rad($x/$period))',
	    "noise" => 0.1
	),
	array(
	    "name" => _("Sinus"),
	    "func" => '$y=sin(deg2rad($x/$period))'
	),
	array(
	    "name" => _("Wide Sinus"),
	    "func" => '$y=5*sin(deg2rad($x/86400))'
	),
	array(
	    "name" => _("Combined Sinuses"),
	    "func" => '$y=8 + 5*sin(deg2rad($x/86400)) + sin(deg2rad($x/$period))/3'
	),
	array(
	    "name" => _("Fading Sinus"),
	    "func" => '
		$scale = 345600;
		$coef = 90 * $scale;
		$tmp=((($x/$coef)%2)?($x%$coef):($coef-1-$x%$coef))/$coef;
		$sin=(3600*(sin(deg2rad(270 + (($coef + $x)%(2*$coef)/$scale)))));
		$y=(3 + 12*$tmp)*sin(deg2rad($sin))
	    '
	)
/*	,
	array(
	    "name" => _("Test"),
	    "func" => '$y=-8 + 5*sin(deg2rad($x/86400)) + sin(deg2rad($x/$period))/3'
	),*/
    );


    $OPTIONS = array_merge ($OPTIONS, array(
	"autogen" => array(
	    "optimize_empty_cache" => true,
	    "maximal_allowed_gap" => 300,
	    "date_limit" => "2005-01-01 00:00:00",
	    "min_resolution" => 600
	),
	"autogen__minutely" => array(
	    "period" => 60,		/* seconds, the data generation period */
	    "items" => &$test_items
	)
    ));

    $ADEI_TIMINGS = array (
	_("1 Year") => 31536000,
	_("1 Month") => 2592000,
	_("1 Week") => 604800,
	_("1 Day") => 86400,
	_("6 Hours") => 21600,
	_("1 Hour") => 3600
    );

?>